using System;
					
public class Program
{
	public static void Main()
	{
	string[] pocetniUlaz = Console.ReadLine().Split();
            int visina = Convert.ToInt32(pocetniUlaz[0]);
            int sirina = Convert.ToInt32(pocetniUlaz[1]);
            int[] sirinaUlaz = new int[1];
            int[,] sve = new int[visina,sirina];
            string[] ulaz;
            int visinaPom = visina;
            int sirinaPom = sirina;
            int j = 0;
            
            while(visinaPom > 0)
            {
                j++;
                sirinaPom = sirina;
                ulaz = Console.ReadLine().Split( );
                for (int i = 0; i < sirinaPom - 1; i++)
                {
                    sve[j,i+1] = Convert.ToInt32(ulaz[i]);
                    
                }
                visinaPom = visinaPom - 1;
                

            }
            visinaPom = visina;
            int visinaTr = 0;
            int sirinaTr = 1;
            int poslednjiPoznatiVazduh = -1;
            int prviPoznatiVazduh = -1;
            int pomocna = 1;
            int[] testiranaSirina = new int[sirina];
            int sirinaTr1 = 1;
            int sirinaP = sirina;
            for(int f = 1; f<sirinaP; f++)
            {
                testiranaSirina[f] = 1;
            }
            while(visinaPom>0)
            {
                visinaTr++;
                for(int k = 1; k<sirina; k++)
                {
                    sirinaTr1 = testiranaSirina[k + 1];

                    if (sve[visinaTr, k] == 0)
                    {
                        testiranaSirina[k] = 0;
                        pomocna = testiranaSirina[k + 1];
                        testiranaSirina[k + 1] = testiranaSirina[k + 1] + testiranaSirina[k];

                    }
                    if(sve[visinaTr, k] == 1)
                    {
                        
                        if(testiranaSirina[k] > 1)
                        {   
                            
                            if((testiranaSirina[k-1]) == 0)
                            {
                               if(poslednjiPoznatiVazduh != - 1)
                                {
                                    if ((testiranaSirina[k] - pomocna) % 2 == 0)
                                    {
                                        testiranaSirina[k] = (testiranaSirina[k] - pomocna) / 2 + testiranaSirina[k];
                                        testiranaSirina[poslednjiPoznatiVazduh] = (testiranaSirina[k] - pomocna) / 2 + testiranaSirina[poslednjiPoznatiVazduh];

                                    }
                                    else
                                    {
                                        if(visinaTr%2 == 1)
                                        {
                                            testiranaSirina[k] = (testiranaSirina[k] - pomocna) / 2 + testiranaSirina[k];
                                            testiranaSirina[poslednjiPoznatiVazduh] = (testiranaSirina[k] - pomocna) / 2 + testiranaSirina[poslednjiPoznatiVazduh] + 1;
                                        }
                                        else
                                        {
                                            testiranaSirina[k] = (testiranaSirina[k] - pomocna) / 2 + testiranaSirina[k] + 1;
                                            testiranaSirina[poslednjiPoznatiVazduh] = (testiranaSirina[k] - pomocna) / 2 + testiranaSirina[poslednjiPoznatiVazduh];

                                        }
                                    }
                                }
                                
                            }
                        }
                        if(prviPoznatiVazduh == -1)
                        {
                            prviPoznatiVazduh = k;
                        }
                        poslednjiPoznatiVazduh = k;

                    }
                    sirinaTr = sirinaTr1;
                    

                    



                }
                visinaPom--;


            }
            for (int g = 1; g < sirina; g++)
            {
                Console.Write(testiranaSirina[g] + " ");
            }	 
            
	}
}